#include <hpcxx_invokeImpl.cc>
#include "Component.h"
#include "PackObject.h"
#include "globus_toolkit.h"
#include "ComponentBase.h"

// PackObject getObj(int nothing)  {
//   HPCxx_ContextID cjunk;
//   PackObject packObject(cjunk);
//   return packObject;
// }

int componentStartpointMethodID = 175;
int catInstantiateMethodID = 242;
int rebindRegistryMethodID = 101;
int bindRegistryMethodID = 102;
int getNameMethodIDofComponent = 224;

Component :: Component() {

  //register all member methods that will be invoked

  int FID1 = hpcxx_register(Component::instantiateComponent, catInstantiateMethodID);
  int FID2 = hpcxx_register(ComponentBase::returnStartpoint, componentStartpointMethodID);
  int FID3 = hpcxx_register(RMIRegistry<Component>::bindRegistry, bindRegistryMethodID);
  int FID4 = hpcxx_register(RMIRegistry<Component>::rebindRegistry, rebindRegistryMethodID);
  int FID5 = hpcxx_register(ComponentBase::getName, getNameMethodIDofComponent);

  int CID1 = hpcxx_registerClass((Component *) NULL);
  int CID2 = hpcxx_registerClass((RMIRegistry<Component> *) NULL);
  int returnValue = gs_init();
  cout << "gs_init() returned: " << returnValue << endl;
  
}

  // globus related stuff so that 
  // an HPC++ component can be instantiated
  // the component resides in path
  // the component needs to be instantiated on machineToRunOn

MyHPCxx_GlobalPtr<Dummy>  Component :: instantiateComponent(HPCxx_String machineToRunOn, HPCxx_String path,  HPCxx_String FQN) {

  PackObject packer;
  HPCxx_ContextID *mCID = new HPCxx_ContextID();
  
  cout << endl <<  "Component :: instantiateComponent " << endl ;
  cout << "path = " <<   path << endl;
  cout << "machineToRunOn : " <<  machineToRunOn << endl ;
  cout << "FQN : " <<  FQN << endl  << endl ;

  // Obtain the startpoint to the remote object


  Dummy *myDummy = new Dummy(1);
  HPCxx_ContextID remoteID;

  hpcxx_connectContext(machineToRunOn); 

 globus_nexus_startpoint_t *remoteSP = (globus_nexus_startpoint_t *)hpcxx_createContext(machineToRunOn, path);

  if (!remoteSP)  {
    printf("\n NULL remoteSP  received by the Gram Server ");
    printf("\n Please check the following file ");
    printf("\n /l/extreme/globus/development/mips-sgi-irix6.5-64_pthreads_standard_debbug/include/globus_gram_client.h");

    //   myDummy->isItNULL = 0; // yes it is null
   MyHPCxx_GlobalPtr<Dummy> myNULLPtr(myDummy);
   myNULLPtr.setItAsNULL();
   printf("\n  Returning a null pointer ... ");
   return myNULLPtr;

//    exit(EXIT_FAILURE);
  }

  cout << "\n Obtained startoint to remote process " << endl;
  fflush(NULL);
  printf("\n remoteSP->mi_proto == %x", remoteSP->mi_proto);
  fflush(NULL);
//  globus_nexus_startpoint_copy(&remoteID, remoteSP);
//  cout << "copied  startoint to remote process " << endl;
//  fflush(NULL);
  HPCxx_GlobalPtr<Dummy> myProcPtr(myDummy, remoteSP);
  
  hpcxx_minvoke(&myProcPtr, packer, componentStartpointMethodID);
  cout << "received packObject from remote process " << endl;
  fflush(NULL);

 // globus_nexus_startpoint_destroy(remoteSP);

  *mCID=packer.GetContextIDPtr();
  cout << "received startpoint from packObject  " << endl;
  fflush(NULL);
  
  MyHPCxx_GlobalPtr<Dummy> testObjGP(myDummy, mCID);

  HPCxx_String name("dummy");
  cout << "Invoking getName method  " << endl;
  fflush(NULL);
  hpcxx_minvoke(&testObjGP, name, getNameMethodIDofComponent);
  cout << "returned from getName method 224  " << endl;
  fflush(NULL);
  cout << "minvoke returned : " << name << endl << flush;
  fflush(NULL);

  testObjGP.setFullyQualifiedFileName(FQN);
  cout << "DummyPtr: " << (*testObjGP).localPtr_ << endl;
  cout << "Dummy.isItNULL: " << ((*testObjGP).localPtr_)->isItNULL << endl;
  return testObjGP;
}

Component :: ~Component() {
}


void hpcxx_pack(HPCxx_Buffer &buf, Component *t,int count) {
}

void hpcxx_unpack(HPCxx_Buffer &buf, Component *t,int count) {
}


//void hpcxx_pack(HPCxx_Buffer &buf, HPCxx_GlobalPtr<HPCxx_Sync<globus_nexus_startpoint_s> > *t, int count) {
//}

//void hpcxx_unpack(HPCxx_Buffer &buf, HPCxx_GlobalPtr<HPCxx_Sync<globus_nexus_startpoint_s> > *t, int count) {
//}


void hpcxx_unpack(HPCxx_Buffer &b, ComponentBase * pw, int count) {}
void hpcxx_pack(HPCxx_Buffer &b, ComponentBase * pw, int count){}






