#include <sys/utsname.h>
#include <hpcxx_invokeImpl.cc>
#include <hpcxx_invoke.h>
#include <stdlib.h>
#include <strings.h>
#include <hpcxx_rts.h>
#include "RMIRegistry.h"
#include "Component.h"
#include "HPCxx_MyType.h"
#include "BindObject.h"

int main(int argc, char **argv) {

  char *serverName = "HPC++GRAM";
  unsigned short PORT = 2112; // DEFAULT PORT IN THE CAT

  int lengthOfName=100;
  char *tempHostName = (char*)malloc(100*sizeof(char));
  int error = gethostname(tempHostName, lengthOfName);
  if (error){
    printf("\n Error ... gethostname() failed ... exiting \n");
    exit(EXIT_FAILURE);
  }

  char *registryHost = strdup(tempHostName);
  free(tempHostName);
  if (argc == 1) {
    cout << "Using Default Parameters" << endl;
    cout << "PORT: " << PORT <<  "\tregistryHost: " << registryHost << endl;
  }
  else  if (argc == 2) {
    PORT = atoi(argv[1]);
    cout << "Using Default Parameters" << endl;
    cout << "registryHost:\t" <<  registryHost << endl;
  } else if (argc == 3) {
    PORT = atoi(argv[1]);
    registryHost = strdup(argv[2]);	
  } else {
    cout << "Usage is : "  << endl;
    cout << "GramServer " << endl;
    cout << "GramServer <PORT> " << endl;
    cout << "GramServer <PORT> <HOST-NAME> " << endl;
    cout << "If host name is not provided, the local host is assumed " << endl;
    cout << "Error ... exiting " << endl;
    exit(EXIT_FAILURE);
  }
  cout << "Using: " << registryHost << " " << PORT << endl;
  
  printf("GramServer: creating global pointer to \"Component\" object\n");
  fflush(stdout);
  Component *componentLocal = new Component();
//  Component compLocal;
  HPCxx_GlobalPtr<Component> gpComponent(componentLocal);
  printf("server-->in main(): global pointer to \"Component\" object created\n");
  fflush(stdout);

  //Get the startpoint of the RMIregistry
  printf("GramServer: attempting RMIRegistry->attachToRegistry() \n");
  fflush(stdout);
  RMIRegistry<Component> *rmiRegistry = new RMIRegistry<Component>();
  int rc = rmiRegistry->attachToRegistry(registryHost, PORT);
  if(rc) {
    printf("\n Error ...RMIRegistry->attachToRegistry() failed ... exiting \n");
  }
  printf("GramServer: RMIRegistry->attachToRegistry() succeeded \n");
  fflush(stdout);

  // register local object "Component" in registry
  printf("server-->in main(): calling bind_registry() to register ..\n");
  printf("server-->\"Component\" at rmi://%s:%hu/%s\n", registryHost, PORT, serverName);
  fflush(stdout);

  char *service = (char *)malloc(sizeof(char)*100);
  sprintf(service, "rmi://%s:%hu/%s", registryHost, PORT, serverName);
  HPCxx_String rmiURL(service);
  cout << "RMIRegistry service requested at " << rmiURL << endl << endl;
  HPCxx_String FQN("dpsecat.cd.HPCxxGRAM");
  rmiRegistry->rebindRegistry(gpComponent, service, FQN);
  free(serverName);
  free(registryHost);
  // waiting to be killed
  HPCxx_Sync<int> s;
  int i2 = s;
}






