#ifndef __MY_GLOBAL_POINTER_PACK_H_
#define __MY_GLOBAL_POINTER_PACK_H_
#include "hpcxx_byte.h"
#include "HPCxx_String.h"
#include <hpcxx_rts.h>
#include <HPCxx_GlobalPtr.h>

template <class T>
class MyHPCxx_GlobalPtr : public HPCxx_GlobalPtr<T> {
public:
  MyHPCxx_GlobalPtr(): isItNULL(1) {}
  MyHPCxx_GlobalPtr(T *ptr) : isItNULL(1) , HPCxx_GlobalPtr<T>(ptr) {}
  MyHPCxx_GlobalPtr(T *ptr, HPCxx_ContextID *sp) : isItNULL(1) , HPCxx_GlobalPtr<T>(ptr, sp) {}
  MyHPCxx_GlobalPtr(const HPCxx_GlobalPtr<T> &gp) : isItNULL(1) ,  HPCxx_GlobalPtr<T>(gp) {}

  void setFullyQualifiedFileName(HPCxx_String name) { FQN = name; }
  void setItAsNULL() { 
    this->isItNULL = 0 ;
  }
  int getIsItNULL() {
    return isItNULL;
  }
  HPCxx_String getFullyQualifiedFileName() { return FQN; }
  static int registrationID() { return 0; }
private:
  HPCxx_String FQN;
  int isItNULL;
};

template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count);
template <class T>
void hpcxx_unpack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count);

#endif // __MY_GLOBAL_POINTER_PACK_H_
