
#include "BindObject.h"

BindObject :: BindObject() {
  // empty Constructor
}
BindObject :: BindObject(HPCxx_String url, HPCxx_String fqn,  nexus_startpoint_t localSP, nexus_startpoint_t  remoteSP) {
  HPCxx_String *tempURL  = new HPCxx_String(url);
  this->rmiURL = *tempURL;
  FQN = fqn;
  remoteObjStartpoint = remoteSP;
  localStartpoint = localSP;
}

BindObject& BindObject :: operator=(BindObject& source) {
  this->remoteObjStartpoint = source.remoteObjStartpoint;
  this->localStartpoint = source.localStartpoint;
  this->rmiURL = source.rmiURL;
  return *this;
}

BindObject :: ~BindObject() {
  // empty destructor
}

void hpcxx_pack(HPCxx_Buffer &buffer, BindObject *t,int count) {
  for(int i=0; i <count; i++) {

    HPCxx_String serializationClass("nexusrmi.HPCxxNexusize");
    // code base is null
    //    char *codeBase = "";

    hpcxx_byte byte_2(2); 
    hpcxx_byte byte_0(0); 
    
    //    cout << "Packing serializationClass " << serializationClass << endl;
    hpcxx_pack(buffer, &serializationClass, 1);
    
    //  The code base is null, so pack byte 0
    //    cout << "Packing byte_0 " << byte_0 << endl;
    hpcxx_pack(buffer, &byte_0, 1);
    
    //  sp of the remote object...
    //  nexus_put_byte(&sendBuffer, &byte_2, 1);
    //    cout << "Packing byte_2 " << byte_2 << endl;
    hpcxx_pack(buffer, &byte_2, 1);
    //    cout << "Packing remoteObjStartpoint" << endl;
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , &(t->remoteObjStartpoint), 1);
    //  obj name:  FQN
    //    cout << "Packing FQN " << FQN << endl;
    hpcxx_pack(buffer, &(t->FQN), 1);
    
    //    cout << "Packing rmiURL " << t->rmiURL << endl;
    hpcxx_pack(buffer, &(t->rmiURL), 1);
    
  }
}

void hpcxx_unpack(HPCxx_Buffer &buf, BindObject *t,int count) {
  for(int i=0; i <count; i++) {

  }
}

