#ifndef MyGlobalPointerPack_cc
#define MyGlobalPointerPack_cc

#include "MyGlobalPointerPack.h"
#include "Component.h"

template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count) {
  cout << "MyGlobalPointerPack() packing " << endl;
  fflush(NULL);
  int sz = count*globus_nexus_sizeof_startpoint((*(r[0])).contextID_, 1)+
    count*sizeof(int)+32;
  if(globus_nexus_check_buffer_size(buffer.impl_.buffer_, sz, sz, 0, 0) < 0) {
    printf("global pointer pack failed\n");
    fflush(NULL);
  }
  fflush(NULL);
  hpcxx_byte byte_5(5);
  hpcxx_byte byte_2(2);
  hpcxx_byte byte_0(0);

  fflush(NULL);
  

  for (int i = 0; i < count; i++) {

//     Component *localPointer = (*(*r)).localPtr_;
  //  if (localPointer->isItNull == 0) {
//    if (r->isItNull == 0) {
 //     cout << "MyHPCxxGlobalPointerPack: packing a null pointer " << endl;
  //    hpcxx_pack(buffer,&byte_0,1); 
   //   break;
    //}

     if (!(r->getIsItNULL())) {
       cout << "MyHPCxxGlobalPointerPack: packing a null pointer " << endl;
       hpcxx_pack(buffer,&byte_0,1); 
       break;

     }
    //java packs byte 5 to indicate remote stub
    hpcxx_pack(buffer,&byte_5,1); 

  
    //pack the fullyQualifiedFileName
    HPCxx_String FQN((r[i]).getFullyQualifiedFileName());
    cout << "FQN being sent back is " << FQN  << endl;
    fflush(NULL);
    hpcxx_pack(buffer,&FQN,1);
    
    // pack the startpoint   
    hpcxx_pack(buffer, &byte_2, 1);

    // cout <<" Packing the startpoint \n " <<endl;
    //fflush(NULL);

    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
   
    // nexus_startpoint_t sp;
    
    // globus_nexus_startpoint_copy(&sp,  gr.contextID_);

    // nexus_put_startpoint_transfer(buffer.impl_.buffer_ , &sp, 1);
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , gr.contextID_, 1);
    
    HPCxx_String serClass("nexusrmi.Nexusize");
    hpcxx_pack(buffer,&serClass,1);
    // 3. The code base
    hpcxx_pack(buffer,&byte_0,1);
    cout << "MyHPCxxGlobalPointerPack: returning RemoteReference " << endl;
    fflush(stdout);
  }
}

template <class T>
void hpcxx_unpack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count) {

  //cerr << "We are unpacking a global pointer!" << endl; 
  for (int i = 0; i < count; i++) {

    hpcxx_byte *k = new hpcxx_byte();
    hpcxx_unpack(buffer,k,1); 

    // FIXME take care of the case when the first byte is a null
    // indicating that it is a null global pointer
    // FIXME FIXME FIXME ... 

    if (k->byte != 5 && k->byte != 6 ) {
      cerr << "Error unpacking HPCxx_GlobaPtr!" << endl;
    }
  
    HPCxx_String FQN;
    hpcxx_unpack(buffer, &FQN, 1);     
    //  cout << "unpack got a globa ptr to " << FQN << endl;
    r->setFullyQualifiedFileName(FQN);
    //unpack the startpoint
  
    hpcxx_unpack(buffer,k,1);
    if (k->byte != 2) {
      cerr << "Error unpacking HPCxx_GlobaPtr!(2)" << endl;
    }
  
    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
    gr.contextID_ = new nexus_startpoint_t;
    nexus_get_startpoint(buffer.impl_.buffer_,gr.contextID_, 1);
    //    nexus_get_int(buffer.impl_.buffer_, &(gr.offset_), 1 );
    gr.offset_ = 0;
    gr.localPtr_ = NULL;
    gr.GlobalEndpoint = NULL;
    //    nexus_printf("\n UnPacked Startpoint");
  }
}

#endif // MyGlobalPointerPack_cc

