#ifndef _RMI_REGISTRY_H__
#define _RMI_REGISTRY_H__

#include "RMIRegistry.h"
#include "temp.h"
#include "GramServer.h"

template <class T>
RMIRegistry<T> :: RMIRegistry() {

   nexus_startpoint_t localStartpoint; 
   nexus_endpoint_t  *localEndpoint;
   localEndpoint = hpcxx_get_ep(); 
   nexus_startpoint_bind(&localStartpoint, localEndpoint);

}

template <class T>
void  RMIRegistry<T> :: attachToRegistry(char *registryHost, unsigned short port) {

  printf("\n RMIRegistry::attach_to_registry(): URL = (%s:%d) \n",registryHost, port);
  char *host = strdup(registryHost);

  int rc = hpcxx_grabContext(&registryStartpoint, host, port);
  
  printf("\n hpcxx_grabContext:  succeeded \n ");
  
  if (rc != 0){
    cout <<"\n Error ...RMIRegistry->attachToRegistry() failed returnValue =  " << rc << endl;
    cout <<"\n Is a NexusRMIregistry running at " << registryHost <<"::" << port <<" ? " <<  endl;
    cout <<"\n  ... Exiting ... " << endl ;
    exit(EXIT_FAILURE);
  }
}

template <class T>
int RMIRegistry<T> :: bindRegistry(HPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN) {
  int bindFID = 102;
  Component component;
  int result;
  HPCxx_GlobalPtr<Component> remoteGP(&component, &registryStartpoint);
  HPCxx_GlobalRefImpl<T> &r = *gp;
  nexus_startpoint_t remoteObjStartpoint;
  nexus_startpoint_copy(&remoteObjStartpoint , r.contextID_);
  
  BindObject bindObject(rmiURL, FQN, localStartpoint, remoteObjStartpoint);
    
  //    HPCxx_GlobalPointer<RMIRegistry> 
  hpcxx_minvoke(&remoteGP, result, bindFID, bindObject);
  cout <<"RMIRegistry-->::bindRegistry(): hpcxx_minvoke() ... returned " << endl << endl;
    
  return SUCCESS;
}

template <class T>
int RMIRegistry<T> :: rebindRegistry(HPCxx_GlobalPtr<T> gp, HPCxx_String rmiURL, HPCxx_String FQN) {
  int rebindFID = 101;
  Component component;
  int result;
  HPCxx_GlobalPtr<Component> remoteGP(&component, &registryStartpoint);
  HPCxx_GlobalRefImpl<T> &r = *gp;
  nexus_startpoint_t remoteObjStartpoint;
  nexus_startpoint_copy(&remoteObjStartpoint , r.contextID_);
  
  BindObject bindObject(rmiURL, FQN, localStartpoint, remoteObjStartpoint);
    
  //    HPCxx_GlobalPointer<RMIRegistry> 
  hpcxx_minvoke(&remoteGP, result, rebindFID, bindObject);
  cout <<"RMIRegistry-->::rebindRegistry(): hpcxx_minvoke() ... returned " << endl << endl;
    
  return SUCCESS;
}


template <class T>
RMIRegistry<T> :: ~RMIRegistry() {
// empty destructor
}

template <class T>
void hpcxx_pack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count) {}

template <class T>
void hpcxx_unpack(HPCxx_Buffer &buf, RMIRegistry<T> *t,int count) {}

// Hopefully these instantiations will finally vanish 
// once we carefully look at temp.h to see what files 
// need to be included 
#ifdef SOLARIS
void hpcxx_pack(HPCxx_Buffer& buf, RMIRegistry<GramServer> *t, int count){}
void hpcxx_unpack(HPCxx_Buffer& buf, RMIRegistry<GramServer>* t, int count) {}
void hpcxx_unpack(HPCxx_Buffer& buf, MyHPCxx_GlobalPtr<Component>* t, int count) {}
#endif // SOLARIS

#endif // _RMI_REGISTRY_H__








